library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity inv_shift_rows is
	Port
	(
		in_shift_rows 	: in   STD_LOGIC_VECTOR (127 downto 0);
		out_shift_rows : out  STD_LOGIC_VECTOR (127 downto 0)
	);
end inv_shift_rows;

architecture shema of inv_shift_rows is

begin

	process(in_shift_rows)
	begin
	
		out_shift_rows(127 downto 120)<=in_shift_rows(127 downto 120);
		out_shift_rows(119 downto 112)<=in_shift_rows(23 downto 16);
		out_shift_rows(111 downto 104)<=in_shift_rows(47 downto 40);
		out_shift_rows(103 downto 96)<=in_shift_rows(71 downto 64);
		
		out_shift_rows(95 downto 88)<=in_shift_rows(95 downto 88);
		out_shift_rows(87 downto 80)<=in_shift_rows(119 downto 112);
		out_shift_rows(79 downto 72)<=in_shift_rows(15 downto 8);
		out_shift_rows(71 downto 64)<=in_shift_rows(39 downto 32);
		
		out_shift_rows(63 downto 56)<=in_shift_rows(63 downto 56);
		out_shift_rows(55 downto 48)<=in_shift_rows(87 downto 80);
		out_shift_rows(47 downto 40)<=in_shift_rows(111 downto 104);
		out_shift_rows(39 downto 32)<=in_shift_rows(7 downto 0);
		
		out_shift_rows(31 downto 24)<=in_shift_rows(31 downto 24);
		out_shift_rows(23 downto 16)<=in_shift_rows(55 downto 48);
		out_shift_rows(15 downto 8)<=in_shift_rows(79 downto 72);
		out_shift_rows(7 downto 0)<=in_shift_rows(103 downto 96);
		
	end process;

end shema;

